// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from derived_object_msgs:msg/SolidPrimitiveWithCovariance.idl
// generated code does not contain a copyright notice

#include "derived_object_msgs/msg/detail/solid_primitive_with_covariance__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_derived_object_msgs
const rosidl_type_hash_t *
derived_object_msgs__msg__SolidPrimitiveWithCovariance__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x94, 0x29, 0xa4, 0xef, 0xee, 0x8d, 0x8d, 0xc0,
      0xe3, 0x4c, 0x82, 0xd6, 0x98, 0x84, 0x34, 0x0e,
      0x09, 0x62, 0xbd, 0xb2, 0x95, 0x6b, 0xbf, 0x7c,
      0xb0, 0xc4, 0xb0, 0x7f, 0x65, 0xba, 0xdb, 0x81,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char derived_object_msgs__msg__SolidPrimitiveWithCovariance__TYPE_NAME[] = "derived_object_msgs/msg/SolidPrimitiveWithCovariance";

// Define type names, field names, and default values
static char derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELD_NAME__type[] = "type";
static char derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELD_NAME__dimensions[] = "dimensions";
static char derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELD_NAME__covariance[] = "covariance";

static rosidl_runtime_c__type_description__Field derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELDS[] = {
  {
    {derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELD_NAME__type, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELD_NAME__dimensions, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELD_NAME__covariance, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
derived_object_msgs__msg__SolidPrimitiveWithCovariance__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {derived_object_msgs__msg__SolidPrimitiveWithCovariance__TYPE_NAME, 52, 52},
      {derived_object_msgs__msg__SolidPrimitiveWithCovariance__FIELDS, 3, 3},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Define box, sphere, cylinder, cone \n"
  "# All shapes are defined to have their bounding boxes centered around 0,0,0.\n"
  "# This message based on shape_msgs/SolidPrimitive\n"
  "\n"
  "# The type of the shape\n"
  "uint8 type\n"
  "uint8 BOX=1\n"
  "uint8 SPHERE=2\n"
  "uint8 CYLINDER=3\n"
  "uint8 CONE=4\n"
  "\n"
  "# The dimensions of the shape\n"
  "float64[] dimensions\n"
  "\n"
  "# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array\n"
  "# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding\n"
  "# sides of the box.\n"
  "uint8 BOX_X=0\n"
  "uint8 BOX_Y=1\n"
  "uint8 BOX_Z=2\n"
  "\n"
  "# For the SPHERE type, only one component is used, and it gives the radius of\n"
  "# the sphere.\n"
  "uint8 SPHERE_RADIUS=0\n"
  "\n"
  "# For the CYLINDER and CONE types, the center line is oriented along\n"
  "# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component\n"
  "# of dimensions gives the height of the cylinder (cone).  The\n"
  "# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the\n"
  "# radius of the base of the cylinder (cone).  Cone and cylinder\n"
  "# primitives are defined to be circular. The tip of the cone is\n"
  "# pointing up, along +Z axis.\n"
  "uint8 CYLINDER_HEIGHT=0\n"
  "uint8 CYLINDER_RADIUS=1\n"
  "\n"
  "uint8 CONE_HEIGHT=0\n"
  "uint8 CONE_RADIUS=1\n"
  "\n"
  "# Row-major representation of the covariance matrix associated with the shape.\n"
  "# For the BOX type, this should be a 3x3 matrix defining the uncertainty of the X, Y, and Z measurements.\n"
  "# For the SPHERE type, this should contain only one value for the radius.\n"
  "# For the CYLINDER and CONE types, this will be a 2x2 matrix defining the uncertainty of the HEIGHT and RADIUS measurements.\n"
  "float64[] covariance";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
derived_object_msgs__msg__SolidPrimitiveWithCovariance__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {derived_object_msgs__msg__SolidPrimitiveWithCovariance__TYPE_NAME, 52, 52},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1588, 1588},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
derived_object_msgs__msg__SolidPrimitiveWithCovariance__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *derived_object_msgs__msg__SolidPrimitiveWithCovariance__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
